/*---------------------------------------------------------------------------
 * Copyright (C) 2008-2010 - Emanuele Bovisio
 *
 * This file is part of Mulk.
 *
 * Mulk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Mulk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Mulk.  If not, see <http://www.gnu.org/licenses/>.
 *
 * In addition, as a special exception, the copyright holders give
 * permission to link the code of portions of this program with the
 * OpenSSL library under certain conditions as described in each
 * individual source file, and distribute linked combinations
 * including the two.
 * You must obey the GNU General Public License in all respects
 * for all of the code used other than OpenSSL.  If you modify
 * file(s) with this exception, you may extend this exception to your
 * version of the file(s), but you are not obligated to do so.  If you
 * do not wish to do so, delete this exception statement from your
 * version.  If you delete this exception statement from all source
 * files in the program, then also delete it here.
 *---------------------------------------------------------------------------*/

#ifndef _MULK_H_
#define _MULK_H_

#ifdef __cplusplus
extern "C" {
#endif

typedef int (*check_exit_cb)(void *context);

typedef void (*write_download_info_cb)(void *context, int ret_code, const char *result,
	int is_http, long http_code, const char *mime_type, const char *url, long size);

extern char mulk_version_number[];

int find_short_option(const char name);
int find_long_option(const char *name);
int set_option(int ind, const char *value);
int set_options(int argc, char **argv);
void add_new_url(const char *url);
void printf_usage(void);
void set_check_exit_cb(check_exit_cb cb, void *context);
void set_write_download_info_cb(write_download_info_cb cb, void *context);

int init_mulk(void);
int run_mulk(void);
void close_mulk(void);

#ifdef __cplusplus
}
#endif

#endif /* not _MULK_H_ */
